import { createStore } from 'wkitd'

export default createStore({
  user: {},
  aboutAppShow: false,
  storeAppShow: true,
  powerAppShow: false,

  categories: [
    { name: '办公教育', icon: 'client', path: '/cate/work' },
    { name: '游戏娱乐', icon: 'game', path: '/cate/game' },
    { name: '编程软件', icon: 'code', path: '/cate/coding' },
    { name: '聊天社交', icon: 'talk', path: '/cate/social' },
    { name: '输入法', icon: 'im', path: '/cate/input-method' },
    { name: '浏览器', icon: 'browser', path: '/cate/browser' },
    { name: '网络工具', icon: 'net', path: '/cate/network' },
    { name: '下载工具', icon: 'download', path: '/cate/download' },
    { name: '视频直播', icon: 'video', path: '/cate/video' },
    { name: '音乐软件', icon: 'music', path: '/cate/music' },
    { name: '图形图像', icon: 'image', path: '/cate/image' },
    { name: '安全防护', icon: 'safe', path: '/cate/safe' },
    { name: '解压记录', icon: 'zip', path: '/cate/zip' },
    { name: '系统工具', icon: 'setting', path: '/cate/system' },
    { name: '股票网银', icon: 'chart', path: '/cate/stock' },
    { name: '剪辑工具', icon: 'cut', path: '/cate/cut' },
    { name: '桌面美化', icon: 'color', path: '/cate/theme' }
  ]
})
